/*
    Project: TCGINA (Keyfile Library/Editor V1.0f)
    Version: V1.15
    File   : secmem.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __SECMEM_H_D47DF546F16B490bA6D8523603A5594D
#define __SECMEM_H_D47DF546F16B490bA6D8523603A5594D

#ifdef SEC_DEBUG
typedef struct
{
    unsigned cAllocations;
    size_t   cbAllocationSize;
    unsigned cMaxAllocations;
    size_t   cbMaxAllocationSize;
} SEC_HEAP_INFORMATION, *PSEC_HEAP_INFORMATION;
#endif

#ifdef __cplusplus
extern "C" {
#endif

int sec_heap_init(void);
void sec_heap_destroy(void);

#define SEC_KEEP_MODE -1
#define SEC_FAIL_ON_LOCK_ERROR 0
#define SEC_IGNORE_LOCK_ERRORS 1
int sec_heap_mode(int new_mode);

void * sec_malloc(size_t size);
void * sec_calloc(size_t num, size_t size);
void * sec_realloc(void *p, size_t new_size);
void sec_free(void *p);
void sec_heap_compact(void);

#ifdef SEC_DEBUG
int sec_heap_status(PSEC_HEAP_INFORMATION pshi);
#endif

#ifdef __cplusplus
}
#endif

#define sec_alloc(p) ((*((void**)&p) = sec_malloc(sizeof(*p))) != NULL)

#endif
