/*
    Project: TCGINA (Keyfile Library/Editor V1.0f)
    Version: V1.15
    File   : kfdlg.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __KFIDLG_H_D47DF546F16B490bA6D8523603A5594D
#define __KFIDLG_H_D47DF546F16B490bA6D8523603A5594D

#include "kfi.h"
#include "kfdlgrc.h"

#define KF_CACHE_SIZE 10

typedef struct {
    CHAR                 aszPassword[KFI_MAX_PASSWORD];
} KF_PASSWORD, *PKF_PASSWORD;

typedef struct {
    KFI_ENCRYPTION_DATA  kfiKeyData;
    KFI_DATA             kfiDecryptedData;
    KF_PASSWORD          rgPasswordCache[KF_CACHE_SIZE];
    CHAR                 aszPassword[KFI_MAX_PASSWORD];
    WCHAR                wszTempPassword[KFI_MAX_PASSWORD];
} KF_SEC_DATA, *PKF_SEC_DATA;

struct s_KF_ENTRY;
typedef struct s_KF_ENTRY KF_ENTRY, *PKF_ENTRY;
struct s_KF_ENTRY
{
    PKF_ENTRY            pNextEntry;

    KFI_DATA             kfiEncryptedData;
    DWORD                dwType;
    DWORD                dwID;
    TCHAR                szDescription[KFI_MAX_DESCRIPTION];

    DWORD                dwTag;
    BOOL                 fModified;
    BOOL                 fRandom;
};

#define KFET_UNKNOWN   0
#define KFET_PLAINTEXT 1
#define KFET_ENCRYPTED 2

typedef struct
{
    PKF_SEC_DATA         pSecData;
    TCHAR                szFileName[MAX_PATH];
#if 0
    LARGE_INTEGER        liFileOffset;
    DWORD                dwFileSize;
#endif
    HINSTANCE            hInstance;

    /* internal data */
    BOOL                 fModified;
    DWORD                dwCacheIndex;
    PKF_PASSWORD         pPasswordCache;
    PKFI_DATA            pkfiDecryptedData;
    PKFI_ENCRYPTION_DATA pkfiKeyData;
    LPSTR                paszPassword;
    LPWSTR               pwszTempPassword;

    PKF_ENTRY            pFirstEntry;
    PKF_ENTRY            pLastEntry;
    DWORD                dwCount;

    HWND                 hwndDlg;
    HWND                 hwndList;
    HCURSOR              hWaitCursor;
    HCURSOR              hArrowCursor;
    BOOL                 fInternalCall;

    DWORD                dwResult;

} KF_DIALOG_DATA, *PKF_DIALOG_DATA;

#ifdef __cplusplus
extern "C" {
#endif

INT_PTR CALLBACK KeyFileDialogProc(HWND hwndDlg, UINT uMsg,
  WPARAM wParam, LPARAM lParam);
BOOL KF_Edit(PKF_DIALOG_DATA pkfdd);

#ifdef __cplusplus
}
#endif

#endif
