/*
    Project: TCGINA (Keyfile Library/Editor V1.0f)
    Version: V1.15
    File   : misc.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __MISC_H_D47DF546F16B490bA6D8523603A5594D
#define __MISC_H_D47DF546F16B490bA6D8523603A5594D

#ifdef _WIN64
#  define SetWindowUserData(hWnd, dwNewLong) \
     SetWindowLongPtr(hWnd, GWLP_USERDATA, (LONG_PTR)dwNewLong)
#  define GetWindowUserData(hWnd) \
     GetWindowLongPtr(hWnd, GWLP_USERDATA)
#else
#  define SetWindowUserData(hWnd, dwNewLong) \
     SetWindowLongPtr(hWnd, GWLP_USERDATA, PtrToLong(dwNewLong))
#  define GetWindowUserData(hWnd) \
     LongToPtr(GetWindowLongPtr(hWnd, GWLP_USERDATA))
#endif

#define ConvertUnicodeToAnsi(paszDest, cbSize, pwszSrc) \
  WideCharToMultiByte(CP_ACP, 0, pwszSrc, -1, paszDest, cbSize, NULL, NULL)
#define ConvertAnsiToUnicode(pwszDest, cchSize, paszSrc) \
  MultiByteToWideChar(CP_ACP, 0, paszSrc, -1, pwszDest, cchSize)

#ifdef UNICODE
#  define CopyString(pszDest, cchSize, pszSrc) \
     CopyStringW(pszDest, cchSize, pszSrc)
#  define AppendString(pszDest, cchSize, pszSrc) \
     AppendStringW(pszDest, cchSize, pszSrc)
#  define CopyStringToAnsi(paszDest, cchSize, pszSrc) \
     ConvertUnicodeToAnsi(paszDest, cchSize, pszSrc)
#  define CopyStringToUnicode(pwszDest, cchSize, pszSrc) \
     CopyString(pwszDest, cchSize, pszSrc)
#  define CopyStringFromAnsi(pszDest, cchSize, paszSrc) \
     ConvertAnsiToUnicode(pszDest, cchSize, paszSrc)
#define CopyStringFromUnicode(pszDest, cchSize, pwszSrc) \
     CopyString(pszDest, cchSize, pwszSrc)
#else
#  define CopyString(pszDest, cchSize, pszSrc) \
     CopyStringA(pszDest, cchSize, pszSrc)
#  define AppendString(pszDest, cchSize, pszSrc) \
     AppendStringA(pszDest, cchSize, pszSrc)
#  define CopyStringToAnsi(paszDest, cchSize, pszSrc) \
     CopyString(paszDest, cchSize, pszSrc)
#  define CopyStringToUnicode(pwszDest, cchSize, pszSrc) \
     ConvertAnsiToUnicode(pwszDest, cchSize, pszSrc)
#  define CopyStringFromAnsi(pszDest, cchSize, paszSrc) \
     CopyString(pszDest, cchSize, paszSrc)
#  define CopyStringFromUnicode(pszDest, cchSize, pwszSrc) \
     ConvertUnicodeToAnsi(pszDest, cchSize, pwszSrc)
#endif

#ifdef __cplusplus
extern "C" {
#endif

BOOL CopyStringA(LPSTR paszDest, size_t cchSize, LPCSTR paszSrc);
BOOL CopyStringW(LPWSTR pwszDest, size_t cchSize, LPCWSTR pwszSrc);
BOOL AppendStringA(LPSTR pszDest, size_t cchSize, LPCSTR pszSrc);
BOOL AppendStringW(LPWSTR pszDest, size_t cchSize, LPCWSTR pszSrc);

#ifdef __cplusplus
}
#endif

#endif
