/*
    Project: TCGINA (Keyfile Library/Editor V1.0f)
    Version: V1.15
    File   : pwdlg.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __PWDLG_H_D47DF546F16B490bA6D8523603A5594D
#define __PWDLG_H_D47DF546F16B490bA6D8523603A5594D

#include "pwdlgrc.h"

#define CP_UTF16 (CP_UTF8+1)

typedef struct
{
    LPCTSTR pszCaption;
    UINT    uCodePage;
    void    *pPassword;
    DWORD   cbPasswordSize;
    DWORD   dwMinPasswordLength;
    DWORD   dwMaxPasswordLength;
    DWORD   dwTimeout;
    DWORD   dwTotalTimeout;
    BOOL    fDisplayPassword;

    /* temporary buffers */
    LPWSTR  pwszTempPassword;
#ifndef NO_PASSWORD_CONFIRMATION_DIALOG
    LPWSTR  pwszConfirmation;
#endif

    /* internal data */
    HWND    hwndOk;
    HWND    hwndPassword;
#ifndef NO_PASSWORD_CONFIRMATION_DIALOG
    HWND    hwndConfirmation;
    HWND    hwndQuality;
#endif
    HWND    hwndLang;
    HWND    hwndNumLock;
    HWND    hwndCapsLock;
    HWND    hwndDisplayPassword;
    DWORD   dwPrevKeyboardStatus;
    DWORD   dwFirstStartTime;
    DWORD   dwStartTime;
    WORD    wPrevLangId;
    BOOL    fRealTimeVerification;
    WPARAM  wPasswordCharacter;
} PASSWORD_DIALOG_DATA, *PPASSWORD_DIALOG_DATA;

#ifdef __cplusplus
extern "C" {
#endif

INT_PTR CALLBACK PasswordDialogProc(HWND hwndDlg, UINT uMsg,
  WPARAM wParam, LPARAM lParam);

#ifdef __cplusplus
}
#endif

#endif
