/*
 * Project: TCGINA (Keyfile Library/Editor V1.0f)
 * Version: V1.15
 * File   : tomcrypt_misc.h
 *
 * This file is part of the LibTomCrypt library V1.04.
 *
 * Some parts of the original LibTomCrypt source code have been modified by
 * the author of TCGINA DLL. The original LibTomCrypt files can be found in
 * the subfolder "crypt-1.04"
 */

/* ---- BASE64 Routines ---- */
#ifdef BASE64
int base64_encode(const unsigned char *in,  unsigned long len,
                        unsigned char *out, unsigned long *outlen);

int base64_decode(const unsigned char *in,  unsigned long len,
                        unsigned char *out, unsigned long *outlen);
#endif

/* ---- MEM routines ---- */
/* void zeromem(void *dst, size_t len); */
#define zeromem(p,s) memset(p, '\0', s)
void burn_stack(unsigned long len);

const char *error_to_string(int err);
int mpi_to_ltc_error(int err);

extern const char *crypt_build_settings;

/* $Source: /cvs/libtom/libtomcrypt/src/headers/tomcrypt_misc.h,v $ */
/* $Revision: 1.2 $ */
/* $Date: 2005/05/05 14:35:58 $ */
