/*
    Project: TCGINA (Setup V1.0m)
    Version: V1.15
    File   : file.c

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#include <windows.h>
#include <tchar.h>
#include "setup.h"

BOOL FileExists(LPCTSTR pszFileName)
{
    HANDLE hFindFile;
    WIN32_FIND_DATA fd;

    hFindFile = FindFirstFile(pszFileName, &fd);
    if (hFindFile == INVALID_HANDLE_VALUE) {
        HANDLE hFile;
        hFile = CreateFile(pszFileName, 0, FILE_SHARE_READ|FILE_SHARE_WRITE,
          NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
        if (hFile != INVALID_HANDLE_VALUE) {
            CloseHandle(hFile);
            return TRUE;
        } else if (GetLastError() == ERROR_ACCESS_DENIED) {
            return TRUE;
        }

        return FALSE;
    }

    FindClose(hFindFile);

    return TRUE;
}

BOOL UninstallFile(LPCTSTR pszFileName, BOOL *fRebootRequired)
{
    if (!FileExists(pszFileName)) {
        return TRUE;
    }
    DeleteFile(pszFileName);
    if (!FileExists(pszFileName)) {
        return TRUE;
    }
    if (MoveFileEx(pszFileName, NULL, MOVEFILE_DELAY_UNTIL_REBOOT)) {
        if (fRebootRequired) {
            *fRebootRequired = TRUE;
        }
        return TRUE;
    }

    return FileExists(pszFileName);
}

BOOL IsTcginaDLL(PFILE_INFO pfi)
{
    if (*pfi->szInfo) {
        return _tcsncmp(pfi->szInfo, TEXT("TCGINA.DLL;"), 11) == 0;
    } else {
        if (_tcsicmp(pfi->szOriginalFileName, TEXT("TCGINA.DLL")) == 0) {
            if (*pfi->szCompanyName == '\0') {
                return TRUE;
            }
        }
    }

    return FALSE;
}
