/*
    Project: TCGINA (Setup V1.0m)
    Version: V1.15
    File   : setup.c

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#include <windows.h>

#ifdef _MSC_VER
#  pragma warning( push )
#  pragma warning( disable : 4201 )
#endif
#include <shlobj.h>
#ifdef _MSC_VER
#  pragma warning( pop )
#endif

#include <tchar.h>
#include <tc.h>
#include "setupdlg.h"

BOOL IsTcginaLog(PFILE_INFO pfi)
{
    BOOL fResult = FALSE;

    if (pfi->fd.nFileSizeHigh == 0 && pfi->fd.nFileSizeLow != 0 &&
      pfi->fd.nFileSizeLow < 0x2000000) {
        HANDLE hFile;
        char *pData = calloc(pfi->fd.nFileSizeLow + 1, 1);
        if (pData) {
            hFile = CreateFile(pfi->fd.cFileName, GENERIC_READ,
              FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
            if (hFile != INVALID_HANDLE_VALUE) {
                DWORD dwFileSize;
                if (ReadFile(hFile, pData, pfi->fd.nFileSizeLow, &dwFileSize,
                  NULL) && pfi->fd.nFileSizeLow == dwFileSize) {
                    strupr(pData);
                    if (strstr(pData, "TCGINA") != NULL &&
                      strstr(pData, "WLXNEGOTIATE") != NULL) {
                        fResult = TRUE;
                    }
                }
                CloseHandle(hFile);
            }
            free(pData);
        }
    }

    return fResult;
}

#ifndef _WIN64
typedef BOOL (WINAPI *PFISWOW64PROCESS) (HANDLE hProcess, PBOOL pfWow64Process);
BOOL IsWow64(void)
{
    BOOL fIsWow64 = FALSE;
    PFISWOW64PROCESS pfIsWow64Process = (PFISWOW64PROCESS) GetProcAddress(
      GetModuleHandle(TEXT("KERNEL32")), "IsWow64Process");

    if (pfIsWow64Process != NULL) {
        pfIsWow64Process(GetCurrentProcess(), &fIsWow64);
    }

    return fIsWow64;
}
#endif

static BOOL AddFileInfo(PFILE_INFO_LIST *ppfil, PFILE_INFO pfi)
{
    PFILE_INFO_LIST pfil;

    if (*ppfil == NULL) {
        pfil = *ppfil = malloc(sizeof(FILE_INFO_LIST));
    } else {
        for (pfil = *ppfil; pfil->pNextItem; pfil = pfil->pNextItem) ;
        pfil = pfil->pNextItem = malloc(sizeof(FILE_INFO_LIST));
    }
    if (pfil == NULL) {
        MessageBox(NULL,
          TEXT("Out of memory error!"),
          TEXT("TCGINA Setup"),
          MB_OK|MB_ICONSTOP);
        return FALSE;
    }
    pfil->pNextItem = NULL;
    pfil->fi = *pfi;

    return TRUE;
}

static BOOL TerminatePath(LPTSTR pszPathName, DWORD cchPath)
{
    size_t cchStr;

    cchStr = _tcslen(pszPathName);
    if (cchStr != 0) {
        TCHAR ch = pszPathName[cchStr - 1];
        if (ch == TEXT('\\') || ch == TEXT('/')) {
            return TRUE;
        }
    }
    if (cchStr+1 >= cchPath) {
        return FALSE;
    }
    pszPathName[cchStr] = TEXT('\\');
    pszPathName[cchStr + 1] = TEXT('\0');

    return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
    OSVERSIONINFO     osvi;
    LPWSTR            *wszArgList;
    int               nArgs;
    TCHAR             szFileName[MAX_PATH];
    TCHAR             szFullPathName[MAX_PATH];
    LPTSTR            pszFilePart;
    HANDLE            hFile;
    WIN32_FIND_DATA   fd;
    SETUP_DIALOG_DATA sdd;
    FILE_INFO         fi;

    UNREFERENCED_PARAMETER(hInstance);
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);
    UNREFERENCED_PARAMETER(nCmdShow);

    memset(&sdd, '\0', sizeof(sdd));

    osvi.dwOSVersionInfoSize = sizeof(osvi);
    if (!GetVersionEx(&osvi) || osvi.dwPlatformId != VER_PLATFORM_WIN32_NT ||
      osvi.dwMajorVersion != 5
#ifndef _WIN64
      || IsWow64()
#endif
      ) {
        MessageBox(NULL, TEXT("Windows Version not supported!"),
          TEXT("TCGINA Setup"), MB_OK|MB_ICONSTOP);
        return 1;
    }

    if (!IsUserAnAdmin()) {
        MessageBox(NULL, TEXT("Administrator privileges are required!"),
          TEXT("TCGINA Setup"), MB_OK|MB_ICONSTOP);
        return 1;
    }

    wszArgList = CommandLineToArgvW(GetCommandLineW(), &nArgs);
    if (wszArgList) {
        LocalFree(wszArgList);
    }

    /* TrueCrypt driver */
#ifndef _WIN64
    GetSystemDirectory(szFileName, MAX_PATH);
    TC_AppendString(szFileName, sizeof(szFileName)/sizeof(TCHAR),
      TEXT("\\drivers\\truecrypt.sys"));
#else
    GetWindowsDirectory(szFileName, MAX_PATH);
    TC_AppendString(szFileName, sizeof(szFileName)/sizeof(TCHAR),
      TEXT("\\SysWOW64\\Drivers\\truecrypt.sys"));
#endif
    GetFileInfo(&sdd.fiTrueCrypt, szFileName);
    if (sdd.fiTrueCrypt.fExists) {
        hFile = CreateFile(TEXT("\\\\.\\TrueCrypt"), 0, 0, NULL,
          OPEN_EXISTING, 0, NULL);
        if (hFile != INVALID_HANDLE_VALUE) {
            sdd.fiTrueCrypt.fInUse = TRUE;
            CloseHandle(hFile);
        } else {
            sdd.fiTrueCrypt.fInUse = GetLastError() == ERROR_ACCESS_DENIED;
        }
    }

    /* GINA DLL */
    *szFileName = TEXT('\0');
    TC_GetRegistryString(HKEY_LOCAL_MACHINE, WINLOGON_KEY, TEXT("GinaDLL"),
      szFileName, MAX_PATH);
    if (*szFileName) {
        SearchPath(NULL, szFileName, TEXT(".DLL"), MAX_PATH,
          szFullPathName, &pszFilePart);
        GetFileInfo(&sdd.fiGinaDLL, szFullPathName);
        sdd.fGinaDLLIsTcginaDLL = IsTcginaDLL(&sdd.fiGinaDLL);
    }

    /* TCGINA Log Files */
    _tcscpy(szFileName, TEXT("C:\\TC.LOG"));
    for (*szFileName = TEXT('A'); *szFileName <= TEXT('Z'); (*szFileName)++) {
        if (TC_GetDriveType(*szFileName) == DRIVE_FIXED) {
            GetFileInfo(&fi, szFileName);
            if (IsTcginaLog(&fi)) {
                if (!AddFileInfo(&sdd.pfilFirstTcginaLog, &fi)) {
                    return 1;
                }
            }

        }
    }
    *szFileName = TEXT('\0');
    GetEnvironmentVariable(TEXT("SystemDrive"), szFileName, MAX_PATH);
    if (*szFileName) {
        TerminatePath(szFileName, MAX_PATH);
        if (TC_AppendString(szFileName, MAX_PATH, TEXT("TC.LOG"))) {
            GetFileInfo(&fi, szFileName);
            if (IsTcginaLog(&fi)) {
                if (!AddFileInfo(&sdd.pfilFirstTcginaLog, &fi)) {
                    return 1;
                }
            }
        }
    }
    *szFileName = TEXT('\0');
    GetEnvironmentVariable(TEXT("SystemRoot"), szFileName, MAX_PATH);
    if (*szFileName) {
        TerminatePath(szFileName, MAX_PATH);
        if (TC_AppendString(szFileName, MAX_PATH, TEXT("TC.LOG"))) {
            GetFileInfo(&fi, szFileName);
            if (IsTcginaLog(&fi)) {
                if (!AddFileInfo(&sdd.pfilFirstTcginaLog, &fi)) {
                    return 1;
                }
            }
        }
    }
    *szFileName = TEXT('\0');
    TC_GetRegistryString(HKEY_LOCAL_MACHINE, TCGINA_KEY,
      TEXT("LogFileName"), szFileName, MAX_PATH);
    GetFileInfo(&fi, szFileName);
    if (IsTcginaLog(&fi)) {
        if (!AddFileInfo(&sdd.pfilFirstTcginaLog, &fi)) {
            return 1;
        }
    }

    /* TCGINA DLLs */
    GetSystemDirectory(szFileName, MAX_PATH);
    TC_AppendString(szFileName, sizeof(szFileName)/sizeof(TCHAR),
      TEXT("\\TCGINA*.DLL"));
    hFile = FindFirstFile(szFileName, &fd);
    if (hFile != INVALID_HANDLE_VALUE) {
        do {
            FILE_INFO fi;
            GetSystemDirectory(szFileName, MAX_PATH);
            TC_AppendString(szFileName, sizeof(szFileName)/sizeof(TCHAR),
              TEXT("\\"));
            TC_AppendString(szFileName, sizeof(szFileName)/sizeof(TCHAR),
              fd.cFileName);
            if (GetFileInfo(&fi, szFileName)) {
                if (IsTcginaDLL(&fi)) {
                    if (!AddFileInfo(&sdd.pfilFirstTcginaDLL, &fi)) {
                        return 1;
                    }
                }
            }
        } while (FindNextFile(hFile, &fd));
        FindClose(hFile);
    }

    if (RegKeyExists(HKEY_LOCAL_MACHINE, TCGINA_ROOT_KEY)) {
        if (RegKeyIsEmpty(HKEY_LOCAL_MACHINE, TCGINA_ROOT_KEY)) {
            sdd.fRegistryKeyExists = TRUE;
        } else if (RegKeyExists(HKEY_LOCAL_MACHINE, TCGINA_KEY)) {
            sdd.fRegistryKeyExists = TRUE;
        }
    }

    if (sdd.fRegistryKeyExists || sdd.pfilFirstTcginaLog != NULL ||
      sdd.fGinaDLLIsTcginaDLL || sdd.pfilFirstTcginaDLL != NULL) {
        if (sdd.fGinaDLLIsTcginaDLL) {
            sdd.iStatus = sdd.fiGinaDLL.fInUse ? TCGS_RUNNING :
              TCGS_INSTALLED;
            if (*sdd.fiGinaDLL.szInfo) {
                TCHAR szConfiguration[80];
                LPTSTR pszVersion = *sdd.fiGinaDLL.szFileVersion ?
                  sdd.fiGinaDLL.szFileVersion : sdd.fiGinaDLL.szVersion;
                GetInfoItem(sdd.fiGinaDLL.szInfo, 2, szConfiguration, 80);
                _sntprintf(sdd.szTcginaVersion, sizeof(sdd.szTcginaVersion)/
                  sizeof(TCHAR), TEXT("%s V%s %s"), sdd.fiGinaDLL.szProductName,
                  pszVersion, szConfiguration);
            } else {
                _sntprintf(sdd.szTcginaVersion, sizeof(sdd.szTcginaVersion)/
                  sizeof(TCHAR), TEXT("%s V%s"), sdd.fiGinaDLL.szProductName,
                    sdd.fiGinaDLL.szFileVersion);
            }
        } else {
            sdd.iStatus = TCGS_PASSIVE;
        }
    }
    sdd.dwNoLMHash = TC_GetRegistryInteger(HKEY_LOCAL_MACHINE, LSA_KEY,
      TEXT("NoLMHash"), 0);

    sdd.pui = GetUserInfo();

    GetPrivateProfileString(TEXT("Setup"), TEXT("Caption"), TEXT(""),
      sdd.szCaption, sizeof(sdd.szCaption)/sizeof(TCHAR),
      GetIniFileName());

    DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_SETUP), NULL,
      SetupDialogProc, (LPARAM)&sdd);

    return 0;
}