/*
    Project: TCGINA (Setup V1.0m)
    Version: V1.15
    File   : setupdlg.h

    Copyright (c) 2005-2006 Author of TCGINA DLL. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.2.4 (MingW32)

mQGiBEI3cVwRBADCRqJ1+AKeMw4BagfF9yNdobBBJXTFQ0R3RJHRAOoKMrT5rxMn
zjRvN9SugcTAftMRVTmsHVZcve6jO2yLHJLg2QgtHiRKdbLV9MTrzYtxXUL1Ez0A
3Mq6ww/h7EdwG5VlPX8uw++Y2aX2UHvMgRbImcLDz+/8qT1FR6dvujjyhwCgmUR9
/4+H8QkCw7M2ekFsODzSBzsEAIwTWuqYfwPRISyGTL/ajZC2WVxLNCC1NmvxzRMe
v/Mg344nxOrMG6MNTNYJdq/3dkiWBzXcpy5zWAVMxAiMDhKSytdk5mdvPI69wZtS
UZ92qXxvm/6fPjIoFy1hSII0LExLuS5p0MMZ7yFFEjZ4CQG/fPE04aUF0zAVgQQ8
OOjJA/0U+8ZlJnPF5cMfvODlOzjfG+LFhWS/t4NhJ12CWeOyn8+enAiXQsKyKyll
JtE9zf8aQKhfS1KJ/ZLZphmnN5LqQLOi/HVsAIK4/KPRrv7M4Z+atChLbmvvR31I
AcTOoDqxj4d8D8yiV8i+ZfLAXREPVLXc3c/W5gBrYwyp5bmpG7QUQXV0aG9yIG9m
IFRDR0lOQSBETEyIXgQTEQIAHgUCQjdxXAIbAwYLCQgHAwIDFQIDAxYCAQIeAQIX
gAAKCRD/R4xyQJdnzk9iAJ9rTCyGTUioEOJEU2w779rVzXoUkQCeO8zdw6QakpiA
uc2XmzGb6JscCEA=
=2DjS
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __SETUPDLG_H_D47DF546F16B490bA6D8523603A5594D
#define __SETUPDLG_H_D47DF546F16B490bA6D8523603A5594D

#include <windows.h>
#include "setup.h"
#include "setupdlgrc.h"

#define PG_NOCHANGE -1
#define PG_STATUS 0
#define PG_INSTALL 1
#define PG_ENCRYPT_USER_PROFILE 2
#define PG_RESET_USER_PROFILE 3
#define PG_UNINSTALL 4

#define TCGS_NOT_AVAILABLE 0
#define TCGS_PASSIVE 1
#define TCGS_INSTALLED 2
#define TCGS_RUNNING 3

#define TCEM_UNKNOWN 0
#define TCEM_COPY 1
#define TCEM_REDIRECT 2

typedef struct
{
    PUSER_INFO      pui;
    FILE_INFO       fiTrueCrypt;
    FILE_INFO       fiGinaDLL;
    PFILE_INFO_LIST pfilFirstTcginaLog;
    PFILE_INFO_LIST pfilFirstTcginaDLL;
    BOOL            fGinaDLLIsTcginaDLL;
    BOOL            fRegistryKeyExists;
    DWORD           dwNoLMHash;
    int             iStatus;
    TCHAR           szTcginaVersion[80];
    TCHAR           szCaption[128];

    /* internal data */
    PFILE_INFO      pfiNewGinaDLL;
    DWORD           dwNewGinaDLLCount;
    int             iPage;
    int             iEncryptionMethod;

    TCHAR           szSrcPath[MAX_PATH];
    TCHAR           szDestPath[MAX_PATH];
    TCHAR           szTrueCryptVolume[MAX_PATH];
    DWORD           dwDrive;
    PUSER_INFO_ITEM puii;

    HWND            hwndOk;
    HWND            hwndCancel;
    HWND            hwndDlg;
    HWND            hwndList;
    HWND            hwndText;
    HWND            hwndInstallLabel;
    HWND            hwndInstallComboBox;
    HWND            hwndInstallText;
    HWND            hwndEncryptLabel1;
    HWND            hwndEncryptComboBox1;
    HWND            hwndEncryptLabel2;
    HWND            hwndEncryptComboBox2;
    HWND            hwndEncryptText;
    HWND            hwndResetLabel;
    HWND            hwndResetComboBox;
    HWND            hwndResetText;
    HWND            hwndUninstallCheckBox1;
    HWND            hwndUninstallCheckBox2;
    HWND            hwndUninstallCheckBox3;
    HCURSOR         hWaitCursor;
    HCURSOR         hArrowCursor;
} SETUP_DIALOG_DATA, *PSETUP_DIALOG_DATA;

#ifdef __cplusplus
extern "C" {
#endif

INT_PTR CALLBACK SetupDialogProc(HWND hwndDlg, UINT uMsg,
  WPARAM wParam, LPARAM lParam);

#ifdef __cplusplus
}
#endif

#endif
